Summary: Common Unix Printing System
Name: cups
Version: 1.1.23
Release: 12tr
License: GPL
Group: Trustix Official
Source: ftp://ftp.easysw.com/pub/cups/cups-%{version}-source.tar.bz2
Source1: cups.init
Source2: cupsprinter.png
Source5: cups-lpd
Source8: postscript.ppd.gz
Source9: cups.logrotate
Source10: ncp.backend
Patch0: cups-1.1.21-install.patch
Patch1: cups-1.1.14-doclink.patch
Patch2: cups-1.1.23-CAN-2005-2097.patch
Patch3: cups-1.1.17-backend.patch
Patch6: cups-1.1.17-pdftops.patch
Patch9: cups-1.1.19-ppdsdat.patch
Patch10: cups-CAN-2004-0888.patch
Patch11: cups-CAN-2005-0064.patch
Patch13: cups-ext.patch
Patch14: cups-sigchld.patch
Patch15: cups-enabledisable.patch
Patch16: cups-gcc34.patch
Patch17: cups-CVE-2005-3191_2_3.patch
Patch18: cups-CVE-2005-3625_6_7.patch 
Url: http://www.cups.org/
BuildRoot: %{_tmppath}/%{name}-root
PreReq: /sbin/chkconfig /sbin/restart_maybe
Requires: %{name}-libs = %{version} xinetd libjpeg libtiff
Requires: ghostscript-cups, /sbin/service
Provides: lpd lpr lprng
BuildPrereq: pam-devel gnutls-devel

%package devel
Summary: Common Unix Printing System - development environment
Group: Trustix Official
Requires: %{name}-libs = %{version} libjpeg libtiff

%package libs
Summary: Common Unix Printing System - libraries
Group: Trustix Official

%package samba
Summary: Common Unix Printing System - samba backend
Group: Trustix Official
Requires: samba-client

%description
The Common UNIX Printing System provides a portable printing layer for 
UNIX(R) operating systems. It has been developed by Easy Software Products 
to promote a standard printing solution for all UNIX vendors and users. 
CUPS provides the System V and Berkeley command-line interfaces. 

%description devel
The Common UNIX Printing System provides a portable printing layer for 
UNIX(R) operating systems. This is the development package for creating
additional printer drivers, and other CUPS services.

%description libs
The Common UNIX Printing System provides a portable printing layer for 
UNIX(R) operating systems. It has been developed by Easy Software Products 
to promote a standard printing solution for all UNIX vendors and users. 
CUPS provides the System V and Berkeley command-line interfaces. 
The cups-libs package provides libraries used by applications to use CUPS
natively, without needing the lp/lpr commands.

%description samba
The Common UNIX Printing System provides a portable printing layer for
UNIX(R) operating systems. 
This package includes bindings to use the samba client as backend.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch6 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1

perl -pi -e 's,^#(Printcap\s+/etc/printcap),$1,' conf/cupsd.conf.in
autoconf

cp %{SOURCE5} cups-lpd.real
perl -pi -e "s,\@LIBDIR\@,%{_libdir},g" cups-lpd.real

%build
%configure --with-docdir=%{_docdir}/cups-%{version} --localstatedir=%{_var} --disable-openssl --enable-gnutls
perl -pi -e "s,^DSO	=.*,DSO=gcc -fpic," Makedefs

# If we got this far, all prerequisite libraries must be here.
make OPTIM="$RPM_OPT_FLAGS $CFLAGS -fpic"

%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf "$RPM_BUILD_ROOT"
mkdir -p $RPM_BUILD_ROOT%{_initdir}

make BUILDROOT=$RPM_BUILD_ROOT install 

install -m 755 $RPM_SOURCE_DIR/cups.init $RPM_BUILD_ROOT%{_initdir}/cups

find $RPM_BUILD_ROOT/usr/share/cups/model -name "*.ppd" |xargs gzip -9f

mkdir -p $RPM_BUILD_ROOT%{_datadir}/pixmaps $RPM_BUILD_ROOT%{_sysconfdir}/xinetd.d $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d $RPM_BUILD_ROOT/var/spool/cups/tmp $RPM_BUILD_ROOT/var/log/cups
install -c -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{_datadir}/pixmaps
install -c -m 755 cups-lpd.real $RPM_BUILD_ROOT%{_sysconfdir}/xinetd.d/cups-lpd
install -c -m 755 %{SOURCE9} $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/cups
install -c -m 755 %{SOURCE10} $RPM_BUILD_ROOT%{_libdir}/cups/backend/ncp
ln -s ../doc/%{name}-%{version} $RPM_BUILD_ROOT%{_datadir}/%{name}/doc
# Deal with users trying to access the admin tool at
# /usr/share/doc/cups-%{version}/index.html rather than the
# correct http://localhost:631/
for i in admin classes jobs printers; do
	mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/$i
	cat >$RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/$i/index.html <<EOF
<?xml version="1.0"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/transitional.dtd">
<html lang="en" xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="refresh" content="2; URL=http://localhost:631/$i" />
<title>CUPS $i</title>
</head>
<body bgcolor="#cccc99" text="#000000" link="#0000ff" vlink="#ff00ff">
<p>You are trying to access the CUPS admin frontend through reading the files.
The correct way to access the CUPS admin frontend is pointing your browser at
<a href="http://localhost:631/">http://localhost:631/</a>.</p>
<p>You should be automatically redirected to the correct URL in 2 seconds.
If your browser does not support redirection, please use
<a href="http://localhost:631/$i">this link</a>.</p>
</body>
</html>
EOF
done

# Add symlink needed for samba backend to work:
ln -s ../../../bin/smbspool $RPM_BUILD_ROOT%{_libdir}/cups/backend/smb

# Ship a generic postscript PPD file (#73061)
install -c -m 644 %{SOURCE8} $RPM_BUILD_ROOT%{_datadir}/cups/model

# Remove unshipped files.
rm -rf $RPM_BUILD_ROOT%{_mandir}/cat? $RPM_BUILD_ROOT%{_mandir}/*/cat?

%post
/sbin/chkconfig --add cups || true

if [ $1 -eq 1 ]; then
  # First install.  Build ppds.dat.
  /usr/sbin/cupsd --ppdsdat
fi
if [ $1 -eq 2 ]; then
  /sbin/restart_maybe cups >/dev/null 2>&1 || :
fi

%preun
if [ "$1" = "0" ]; then
	/sbin/service cups stop > /dev/null 2>&1
	/sbin/chkconfig --del cups
fi

%post libs -p /sbin/ldconfig

%postun libs -p /sbin/ldconfig

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf "$RPM_BUILD_ROOT"

%files
%defattr(-,root,root,0755)
%dir %attr(0755,lp,sys) /etc/cups
%dir %attr(0711,lp,sys) /etc/cups/certs
%config(noreplace) %attr(0600,lp,sys) /etc/cups/classes.conf
%config(noreplace) %attr(0600,lp,sys) /etc/cups/cupsd.conf
%config(noreplace) %attr(0600,lp,sys) /etc/cups/printers.conf
%config(noreplace) /etc/cups/client.conf
/etc/cups/interfaces
/etc/cups/mime.types
/etc/cups/mime.convs
%dir %attr(0755,lp,sys) /etc/cups/ppd
/etc/pam.d/cups
%doc %{_docdir}/cups-%{version}
%{_initdir}/cups
%{_bindir}/cancel*
%{_bindir}/enable*
%{_bindir}/disable*
%{_bindir}/lp*
%{_bindir}/cups*
%{_libdir}/cups
%{_mandir}/man?/*
%{_sbindir}/*
%{_datadir}/cups
%{_datadir}/locale/*/*
%dir %attr(1700,lp,sys) /var/spool/cups/tmp
%dir %attr(0700,lp,sys) /var/spool/cups
%dir %attr(0755,lp,sys) /var/log/cups
%config(noreplace) %{_sysconfdir}/xinetd.d/cups-lpd
%config(noreplace) %{_sysconfdir}/logrotate.d/cups
%{_datadir}/pixmaps/cupsprinter.png
%exclude %{_mandir}/??/
%exclude /etc/rc.d/*

%files libs
%defattr(-,root,root,0755)
%{_libdir}/*.so.*

%files devel
%defattr(-,root,root,0755)
%{_bindir}/cups-config
%{_libdir}/*.so
%{_libdir}/*.a
%{_includedir}/cups

%files samba
%defattr(-,root,root,0755)
%{_libdir}/cups/backend/smb

%changelog
* Mon Mar 05 2007 Nived Gopalan <nived at trustix dot org> 1.1.23-12tr
- Load usblp module for USB printers, Bug #1699.

* Mon Jan 09 2006 Nived Gopalan <nived at trustix dot org> 1.1.23-11tr
- SECURITY Fix: Chris Evans has reported some vulnerabilities in xpdf,
  which can be exploited by malicious people to cause a DoS.
- Integer overflow error exists in "Stream.cc:StreamPredictor::StreamPredictor()"
  and "Stream.cc::CCITTFaxStream::CCITTFaxStream()" when calculating buffer
  sizes for memory allocation. This can potentially be exploited to 
  overflow the allocated heap memory.
- An infinite loop error exists in "Stream.cc::DCTStream::readMarker()"
  when handling certain malformed input files. This can potentially be
  exploited to cause a DoS.
- Missing validation of input parameters in 
  "Stream.cc:DCTStream::readHuffmanTables()" and 
  "Stream.cc:DCTStream::readScanInfo()" can cause out-of-bounds memory access.
  This can potentially be exploited to overwrite certain memory.
- Some potential integer overflow error exists in "JBIG2Stream.cc".

  The Common Vulnerabilities and Exposures project has assigned the
  name CVE-2005-3624, CVE-2005-3625, CVE-2005-3626 and CVE-2005-3627
  to these issues.

* Fri Dec 16 2005 Nived Gopalan <nived at trustix dot org> 1.1.23-10tr
- SECURITY Fix: Some vulnerabilities have been reported in CUPS, which
  can be exploited by malicious people to cause a DoS (Denial of Service)
  and potentially to compromise a vulnerable system. The vulnerabilities
  are caused due to the use of a vulnerable version of Xpdf.

  The Common Vulnerabilities and Exposures project has assigned the
  name CVE-2005-3191, CVE-2005-3192 and CVE-2005-3193 to this issue.

* Thu Aug 11 2005 Syed Shabir Zakiullah <syedshabir at comodo dot com> 1.1.23-9tr
- SECURITY: xpdf Temporary File Writing Denial of Service
- When processing a PDF file, bounds checking was not correctly performed on
  some fields.  This could cause the pdftops filter (running as user "lp") to
  crash.  
 
  The Common Vulnerabilities and Exposures project has assigned the
  name CAN-2005-2097 to this issue.

* Wed May 25 2005 Chr. Toldnes <christht at trustix dot org> 1.1.23-7tr
- service cups condrestart not needed in %postun with restart_maybe in %post
- samba binding in separate package instead of crappy trigger scripts.
- Don't runservice cups reload after first install, just build the db.

* Wed May 25 2005 Ajith Thampi <ajith at comodo dot com> 1.1.23-6tr
- cups should not attempt service start after install but only if it
  is an upgrade

* Tue May 24 2005 Erlend Midttun <erlendbm at trustix dot org> 1.1.23-5tr
- Nuke startup symlinks from package.

* Thu May 12 2005 Ajith Thampi <ajith at comodo dot com> 1.1.23-4tr
- Fix auto loading of printer modules in init, Bug #630

* Mon Apr 25 2005 Syed Shabir Zakiullah <syedshabir at comodo dot com> 1.1.23-3tr
- Rebuilt against gcc4.0

* Fri Mar 18 2005 Ajith Thampi <ajith at comodo dot com> 1.1.23-2tr
- Fixed Unpackaged Filelist

* Mon Mar 07 2005 Ajith Thampi <ajith at comodo dot com> 1.1.23-1tr
- New Upstream

* Thu Mar 03 2005 Ajith Thampi <ajith at comodo dot com> 1.1.21-3tr
- Rebuild with gnutls

* Tue Nov  9 2004 Oystein Viggen <oysteivi at trustix dot com> 1.1.21-2tr
- Rebuild with shared openssl

* Mon Sep 20 2004 Erlend Midttun <erlendbm at trustix dot org> 1.1.21-1tr
- New upstream.

* Fri Dec 12 2003 Erlend Midttun <erlendbm at trustix dot org> 1.1.20-1tr
- New upstream.

* Thu Jun 26 2003 Gerald Dachs <gda at trustix dot org> 1.1.19-6tr
- moved foomatic-filters to an own package to prevent double inclusion
  of files

* Thu Jun 26 2003 Gerald Dachs <gda at trustix dot org> 1.1.19-5tr
- added package foomatic-filters
  based on work by Derek Battams derek at battams dot ca>

* Wed Jun 18 2003 Erlend Midttun <erlendbm at trustix dot com> 1.1.19-4tr
- Big rebuild

* Tue Jun 10 2003 Chr. Toldnes <christht at trustix dot org> 1.1.18-3ct
- Removed french manual pages.

* Wed May 28 2003 Gerald Dachs <gda at trustix dot org> 1.1.18-2gd
- reinserted patch9 for generation of pdds data

* Tue May 27 2003 Gerald Dachs <gda at trustix dot org> 1.1.19-1gd
- new upstream version, fixes a denial-of-service attack vulnerability 

* Wed Apr 23 2003 Gerald Dachs <gda at trustix dot org> 1.1.18-3gd
- doesn't start anymore on boot by default 
- cleaned up requirements, libpng10 is not need anymore

* Mon Apr 14 2003 Gerald Dachs <gda at trustix dot org> 1.1.18-2gd
- changed requirements
- rebuild against new libpng10, libjpg, libtiff

* Thu Apr 10 2003 Gerald Dachs <gda at trustix dot org> 1.1.18-1gd
- initial release
